/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	属性変更 複製元クラス
//			変更履歴
//				2004.07.21 新規作成 A.Shimoma
//
package jp.co.ntt.lms.xmo.Lo;

import java.sql.SQLException;
import java.util.Hashtable;

import org.apache.commons.lang.StringEscapeUtils;

import jp.co.ntt.lms.lo.LOException;
import jp.co.ntt.lms.lo.LoPropertyDef;
import jp.co.ntt.lms.xmo.DataAccess;
import jp.co.ntt.lms.xmo.XMOException;
import jp.co.ntt.lms.xmo.XMOPropertyDef;
import jp.co.ntt.lms.xmo.util.DebugLog;

/**
 * 
 * このクラスは属性変更対象LOの他参照(同リアルLOID)があり、
 * 且つ属性変更対象LOのLOIDとリアルLOIDが 同IDの場合に実行するクラスです。
 * 
 * @author A.Shimoma
 *  
 */
public class ChangeTypeBaseLo extends ChangeTypeAbstract {

	/**
	 * コンストラクタ
	 *  
	 */
	public ChangeTypeBaseLo() {
	}

	/**
	 * LOテーブルの更新を行います。
	 * 
	 * 属性変更対象LOの場合は、 LOTypeをコンテナ｢0｣で更新を行います。
	 * 属性変更対象LO以外(複製先)の場合は、リアルLOIDを最小LOIDで更新を行います。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeLoAction()
	 */
	void changeLoAction() throws XMOException {

		for ( int i = 0; i < copyList.size(); i++ ){
			// 他参照LOIDを取得
			String strLoID = ( String ) copyList.get( i );
			// 複製元LOの場合
			// LOTypeをコンテナ｢0｣へ更新のみ行います。
			if ( strLoID.equals( loID ) ){
				putLoTableData( strLoID, realLoID, CONTAINER_TYPE, condition );
			}
			// 複製先LOの場合
			// リアルLOIDの更新のみ行います。
			else{
				String strCondition = " WHERE " + LO_ID + "='" + StringEscapeUtils.escapeSql(strLoID) + "'";
				putLoTableData( strLoID, newLoID, null, strCondition );
			}
		}
	}

	/**
	 * ログセッションテーブルの更新を行います。
	 * 
	 * 複製元のLOIDをキーに最小LOIDに更新します。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeLoLogSessionAction()
	 */
	void changeLoLogSessionAction() throws XMOException {

		Hashtable htData = new Hashtable();
		// 最小LOIDをハッシュパラメータへ設定する
		htData.put( LO_ID, newLoID );

		try{

			// ログセッションテーブル更新
			// 複製元のLOIDをキーに最小LOIDへ更新します。
			objLogSession.updateAction( htData, null, loID, null,
										objDataAccess );

		} catch ( SQLException se ){
			DebugLog.write( this.getClass(), se, DebugLog.HIGHT );
			throw new XMOException( getMessageData( DB_ERR ) );
		}
	}

	/**
	 * 共通ログの登録を行います。
	 * 
	 * 最小LOIDをキーに登録します。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeLoLogAction()
	 */
	void changeLoLogAction() throws XMOException {

		try{

			// 共通ログ情報を取得し、最小LOIDで登録し直します。
			objLogUtil.changeType( realLoID, newLoID, objDataAccess );

		} catch ( LOException se ){
			DebugLog.write( this.getClass(), se, DebugLog.HIGHT );
			throw new XMOException( getMessageData( DB_ERR ) );
		}
	}

	/**
	 * 評価テーブルの更新を行います。
	 * 
	 * 複製元のLOIDをキーに最小LOIDに更新します。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeEvaluteAction()
	 */
	void changeEvaluteAction() throws XMOException {

		Hashtable htData = new Hashtable();

		// トランザクション共有のために現在使用中のコネクションインデックスを取得する
		Integer objConIndex = getConnectionIndex();

		// 最小LOIDをハッシュパラメータへ設定する
		htData.put( LO_ID, newLoID );
		htData.put( CONDITION_KEY, condition );
		htData.put( DataAccess.CONNECTIONINDEX, objConIndex );
		objEvalute.changeTypeUpdate( htData );
	}

	/**
	 * 更新履歴テーブルへの登録を行います。
	 * 
	 * 属性変更対象LOの更新履歴レコードをコピーし最小LOIDで更新します。
	 * 最後に属性変更分の新規レコードを登録します。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeLoHistoryAction()
	 */
	void changeLoHistoryAction() throws XMOException {

		try{

			// 属性変更前の履歴を引き継ぐ(該当LOIDデータを登録)
			Hashtable htbChangeParam = new Hashtable();

			htbChangeParam.put( LOGIN_USER_ID, userID );
			htbChangeParam.put( REAL_LOID, loID );
			htbChangeParam.put( LO_ID, newLoID );
			// 属性変更対象LOIDを元に最小LOIDで更新
			objLoDataAccess.ChangeTypeHistory( htbChangeParam, objDataAccess );
			// 最小LOIDをキーに現在日付を挿入
			objLoDataAccess.insertHistoryAction( htbChangeParam, objDataAccess );

		} catch ( SQLException se ){
			DebugLog.write( this.getClass(), se, DebugLog.HIGHT );
			throw new XMOException( getMessageData( DB_ERR ) );
		}
	}

	/**
	 * 個別ログの更新を行います。
	 * 
	 * 複製元のLOIDをキーに最小LOIDに更新します。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeIndividualLogAction()
	 */
	void changeIndividualLogAction() throws XMOException {

		objLoTop.clear();

		if ( !objLoTop.changeTypeUpdateIndividualLog( newLoID, condition ) ){
			throw new XMOException( objLoTop.getMessageData() );
		}

	}

	/**
	 * LO個別テーブルの更新を行います。
	 * 
	 * 複製元のLOIDをキーに最小LOIDに更新します。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeOriginalLoAction()
	 */
	void changeOriginalLoAction() throws XMOException {

		Hashtable htData = new Hashtable();
		htData.put( LO_ID, newLoID );
		htData.put( CONDITION_KEY, condition );
		htData.put( LoPropertyDef.BASE_LOID, loID );
		htData.put( LoPropertyDef.LO_TYPE, loType );
		// LO個別情報更新処理
		if ( !objLoTop.setUp( LoPropertyDef.SETUP_UPDATE, htData ) ){
			throw new XMOException( objLoTop.getMessageData() );
		}

	}

	/**
	 * 最小LOIDを取得します。
	 * 
	 * 属性変更対象LOの同リアルLOIDを持つLOの中から
	 * 最小のLOID(属性変更対象LOを除く)を取得します。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#setMinimumLoID()
	 */
	void setMinimumLoID() {

		// LOIDの比較変数(初期値はint型のmax値)
		int minLoID = Integer.MAX_VALUE;
		// 他参照分ループしLOIDの大小比較を行います。
		for ( int i = 0; i < copyList.size(); i++ ){
			// 比較する他参照LOIDを取得
			String tmpLOID = ( String ) copyList.get( i );
			if ( tmpLOID.startsWith( XMOPropertyDef.PREFIX_LOID )
					&& !tmpLOID.equals( loID ) ){
				// ｢LO｣を除いた数値部分を取得
				String strsub = tmpLOID.substring( 
					XMOPropertyDef.PREFIX_LOID.length() );
				int numtemp = Integer.parseInt( strsub );
				// 大小比較
				if ( minLoID > numtemp ){
					// 最小値としてLOIDの比較変数に代入
					minLoID = numtemp;
				}
			}
		}
		// ｢LO｣と最小値を結合したLOIDを返却する。
		newLoID = XMOPropertyDef.PREFIX_LOID + minLoID;
	}

}